<?php
/**
 * @package     3.x
 * @subpackage  J2 Store Easy Checkout
 * @author      Alagesan, J2Store <support@j2store.org>
 * @copyright   Copyright (c) 2018 J2Store . All rights reserved.
 * @license     GNU GPL v3 or later
 * @link        http://j2store.org
 * --------------------------------------------------------------------------------
 *
 * */
/** ensure this file is being included by a parent file */
defined('_JEXEC') or die('Restricted access');
jimport('joomla.filesystem.file');

// Load FOF if not already loaded
if (!defined('F0F_INCLUDED'))
{
    $paths = array(
        (defined('JPATH_LIBRARIES') ? JPATH_LIBRARIES : JPATH_ROOT . '/libraries') . '/f0f/include.php',
        __DIR__ . '/fof/include.php',
    );

    foreach ($paths as $filePath)
    {
        if (!defined('F0F_INCLUDED') && file_exists($filePath))
        {
            @include_once $filePath;
        }
    }
}

class Com_easycheckoutInstallerScript extends F0FUtilsInstallscript{

    /**
     * The component's name
     *
     * @var   string
     */
    protected $componentName = 'com_easycheckout';

    /**
     * The title of the component (printed on installation and uninstallation messages)
     *
     * @var string
     */
    protected $componentTitle = 'Easy Checkout for J2Store';


    protected $minimumJoomlaVersion = '3.4.0';
    /**
     * The list of extra modules and plugins to install on component installation / update and remove on component
     * uninstallation.
     *
     * @var   array
     */
    protected $installation_queue = array(		// modules => { (folder) => { (module) => { (position), (published) } }* }*

        'plugins' => array(
            'system' 		=> 		array(
                'easycheckout' => 1
            )

        )
    );

    public function preflight($type, $parent) {

        if(!JComponentHelper::isEnabled('com_j2store')) {
            JError::raiseWarning(null, 'J2Store not found. Please install J2Store before installing this plugin');
            return false;
        }

        jimport('joomla.filesystem.file');
        $version_file = JPATH_ADMINISTRATOR.'/components/com_j2store/version.php';
        if (JFile::exists ( $version_file )) {
            require_once($version_file);
            // abort if the current J2Store release is older
            if (version_compare ( J2STORE_VERSION, '3.3.0', 'lt' )) {
                JError::raiseWarning ( null, 'You need at least J2Store 3.3.0 for this app to work' );
                return false;
            }
        } else {
            JError::raiseWarning ( null, 'J2Store not found or the version file is not found. Make sure that you have installed J2Store before installing this plugin' );
            return false;
        }

        return true;
    }
}