<?php
/**
 * @package J2Store
 * @copyright Copyright (c)2014-17 Ramesh Elamathi / J2Store.org
 * @license GNU GPL v3 or later
 */
defined('_JEXEC') or die;
?>
<div id="variant_add_block">
    <input type="hidden" name="flexi_product_id" value="<?php echo $this->item->j2store_product_id;?>"/>
    <?php foreach ($this->item->product_options as $product_option): ?>
        <select name="varient_combin[<?php echo $product_option->j2store_productoption_id;?>]">
            <option value="0"><?php echo substr(JText::_('JALL').' '.$product_option->option_name,0,10).'...';?></option>
            <?php foreach ($product_option->option_values as $option_value): ?>
                <option value="<?php echo $option_value->j2store_optionvalue_id;?>"><?php echo $option_value->optionvalue_name;?></option>
            <?php endforeach; ?>
        </select>
    <?php endforeach; ?>
    <a onclick="addFlexiVariant()" class="btn btn-info"><?php echo JText::_('J2STORE_ADD_VARIANT');?></a>
    <a onclick="remvoeFlexiAllVariant()" class="btn btn-danger"><?php echo JText::_('J2STORE_REMOVE_ALL_VARIANT');?></a>
</div>
<div id="variant_display_block">
    <!-- Advanced variable starts here  -->
    <div class="bs-example j2store-advancedvariants-settings">
        <div class="panel-group" id="accordion">
            <?php
            /* to get ajax advanced variable list need to
             *  assign these variables
             */
            $this->variant_list = $this->item->variants;
            $this->variant_pagination =$this->item->variant_pagination;
            $this->weights = $this->item->weights;
            $this->lengths = $this->item->lengths;

            ?>
            <?php  echo $this->loadTemplate('ajax_flexivariableoptions');?>
        </div>
    </div>
</div>

<script type="text/javascript">
    function addFlexiVariant() {
        (function ($) {
            var data = $('#variant_add_block select,#variant_add_block input').serializeArray();
            console.log(data);

            var j2Ajax = $.ajax({
                url: 'index.php?option=com_j2store&view=apps&task=view&id=<?php echo $this->item->app_detail->extension_id;?>&appTask=addFlexiVariant&form_prefix=<?php echo $this->form_prefix;?>',
                type: 'post',
                data: data,
                dataType: 'json'

            });
            j2Ajax.done(function(json) {
                if(json['html']){
                    $('#variant_display_block').html(json['html'])
                }

            }).fail(function( jqXHR, textStatus, errorThrown) {
                console.log(textStatus + errorThrown);
            }).always(function(jqXHR, textStatus, errorThrown) {
                    //form.find('input[type=\'submit\']').val(form.find('input[type=\'submit\']').data('cart-action-always'));
            });
        })(j2store.jQuery);
    }

    function remvoeFlexiAllVariant() {
        (function ($) {
            var delete_var_data = {
                option: 'com_j2store',
                view: 'apps',
                task: 'view',
                id: '<?php echo $this->item->app_detail->extension_id;?>',
                appTask: 'deleteAllVariant',
                product_id: '<?php echo $this->item->j2store_product_id;?>'
            };
            $.ajax({
                url: '<?php echo JRoute::_('index.php');?>',
                data: delete_var_data,
                beforeSend: function () {

                },
                success: function (json) {
                    if (json) {
                        window.location.reload();
                    }
                }
            });
        })(j2store.jQuery);
    }
</script>
